module Paths_cash (
    version,
    getBinDir, getLibDir, getDataDir, getLibexecDir,
    getDataFileName
  ) where

import Data.Version (Version(..))
import System.Environment (getEnv)

version :: Version
version = Version {versionBranch = [0,1,0,0], versionTags = []}

bindir, libdir, datadir, libexecdir :: FilePath

bindir     = "/Users/chrisb/Library/Haskell/ghc-7.0.4/lib/cash-0.1.0.0/bin"
libdir     = "/Users/chrisb/Library/Haskell/ghc-7.0.4/lib/cash-0.1.0.0/lib"
datadir    = "/Users/chrisb/Library/Haskell/ghc-7.0.4/lib/cash-0.1.0.0/share"
libexecdir = "/Users/chrisb/Library/Haskell/ghc-7.0.4/lib/cash-0.1.0.0/libexec"

getBinDir, getLibDir, getDataDir, getLibexecDir :: IO FilePath
getBinDir = catch (getEnv "cash_bindir") (\_ -> return bindir)
getLibDir = catch (getEnv "cash_libdir") (\_ -> return libdir)
getDataDir = catch (getEnv "cash_datadir") (\_ -> return datadir)
getLibexecDir = catch (getEnv "cash_libexecdir") (\_ -> return libexecdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
